MODULE dimensions

    INTEGER :: iim
    INTEGER :: jjm
    INTEGER :: ii_begin
    INTEGER :: jj_begin
    INTEGER :: ii_end
    INTEGER :: jj_end
    INTEGER :: ii_nb
    INTEGER :: jj_nb
    INTEGER :: ij_begin
    INTEGER :: ij_end
    INTEGER :: ij_begin_ext
    INTEGER :: ij_end_ext
        
    INTEGER :: t_right
    INTEGER :: t_rup
    INTEGER :: t_lup
    INTEGER :: t_left
    INTEGER :: t_ldown
    INTEGER :: t_rdown

    INTEGER :: u_right
    INTEGER :: u_rup
    INTEGER :: u_lup
    INTEGER :: u_left
    INTEGER :: u_ldown
    INTEGER :: u_rdown

    INTEGER :: z_rup
    INTEGER :: z_up
    INTEGER :: z_lup
    INTEGER :: z_ldown
    INTEGER :: z_down
    INTEGER :: z_rdown

    INTEGER :: t_pos(6)
    INTEGER :: u_pos(6)
    INTEGER :: z_pos(6)
        
CONTAINS

  SUBROUTINE swap_dimensions(ind)
  USE domain_mod
  IMPLICIT NONE
    INTEGER,INTENT(IN) :: ind
    
    TYPE(t_domain),POINTER :: d
    
    
!$OMP MASTER
    d=>domain(ind)
     
     iim=d%iim
     jjm=d%jjm
     ii_begin=d%ii_begin
     jj_begin=d%jj_begin
     ii_end=d%ii_end
     jj_end=d%jj_end
     ii_nb=d%ii_nb
     jj_nb=d%jj_nb
    
     ij_begin=(jj_begin-1)*iim+ii_begin
     ij_end=(jj_end-1)*iim+ii_end 
     ij_begin_ext=((jj_begin-1)-1)*iim+ii_begin-1
     ij_end_ext = ((jj_end+1)-1)*iim+ii_end+1
        
     t_right=d%t_right
     t_rup=d%t_rup
     t_lup=d%t_lup
     t_left=d%t_left
     t_ldown=d%t_ldown
     t_rdown=d%t_rdown

     u_right=d%u_right
     u_rup=d%u_rup
     u_lup=d%u_lup
     u_left=d%u_left
     u_ldown=d%u_ldown
     u_rdown=d%u_rdown

     z_rup=d%z_rup
     z_up=d%z_up
     z_lup=d%z_lup
     z_ldown=d%z_ldown
     z_down=d%z_down
     z_rdown=d%z_rdown
     
     t_pos(:)=d%t_pos(:)
     u_pos(:)=d%u_pos(:)
     z_pos(:)=d%z_pos(:)

!$OMP END MASTER     
!$OMP BARRIER
   END SUBROUTINE swap_dimensions
   
END MODULE dimensions   
    
